<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'aftersale';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/order.class.php');
$dou_order = new Order();

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/aftersale.class.php');
$dou_aftersale = new Aftersale();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 售后列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['aftersale']);
 
    // SESSION 与 REQUEST 互转
    if ($_REQUEST['key']) {
        $_SESSION['req'] = $_REQUEST;
    } else {
        if (isset($_REQUEST['menu'])) unset($_SESSION['req']);
        foreach ((array)$_SESSION['req'] as $key => $value) {
            $_REQUEST[$key] = $value;
        }
    }

    // 验证并获取合法的REQUEST
    $aftersale_sn = $check->is_number($_REQUEST['aftersale_sn']) ? $_REQUEST['aftersale_sn'] : '';
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    
    // 初始化
    $page_url = 'aftersale.php';

    // 筛选.类型
    if ($aftersale_sn) {
        $where = $where . " AND aftersale_sn LIKE '%$aftersale_sn%'";
        $page_url = $page_url . "&aftersale_sn=$aftersale_sn";
    }
 
    // 筛选.时间
    if ($time_start) {
        $where = $where . " AND add_time > '" . strtotime($time_start) . "'";
        $page_url = $page_url . "&time_start=$time_start";
    }
    if ($time_end) {
        $where = $where . " AND add_time < '" . strtotime($time_end) . "'";
        $page_url = $page_url . "&time_end=$time_end";
    }
 
    // 把第一个AND替换成WHERE
    $where = $_SESSION['where'] = $dou->where($where);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('aftersale') . $where . " ORDER BY aftersale_id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, $dou->param($page_url), $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        // 订单信息
        $order = $dou->get_row('order', 'order_id, order_sn, order_amount, shipping_time', "order_id = '$row[order_id]'");
        $order['shipping_time'] = date("Y-m-d", $order['shipping_time']);
        
        // 会员信息
        $user = $dou->get_row('user', 'user_id, user_sn, email', "user_id = '$row[user_id]'");
        
        $aftersale_list[] = array (
                "aftersale_id" => $row['aftersale_id'],
                "aftersale_sn" => $row['aftersale_sn'],
                "order" => $order,
                "user" => $user,
                "aftersale_money" => $row['aftersale_money'] > 0 ? $dou->price_format($row['aftersale_money']) : '无退款',
                "item_list" => $dou_aftersale->get_aftersale_item_list($row['order_id'], unserialize($row['item_list'])),
                "reason" => $row['reason'],
                "handle_record" => $row['handle_record'],
                "status" => $dou->data_lang_format('aftersale_status_', $row['status']),
                "is_handle" => $row['status'] ? true : false,
                "add_time" => date("Y-m-d H:i:s", $row['add_time'])
                
        );
    }
    
    // 赋值给模板
    $smarty->assign('req', $_REQUEST);
    $smarty->assign('aftersale_list', $aftersale_list);
    
    $smarty->display('aftersale.htm');
} 

/**
 * +----------------------------------------------------------
 * 售后编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'view') {
    $smarty->assign('ur_here', $_LANG['aftersale']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['aftersale_list'],
            'href' => 'aftersale.php' 
    ));
    
    // 验证并获取合法的ID
    $aftersale_id = $check->is_number($_REQUEST['aftersale_id']) ? $_REQUEST['aftersale_id'] : '';
    
    // 格式化服务单信息
    $aftersale = $dou->get_row('aftersale', '*', "aftersale_id = '$aftersale_id'");
    $aftersale['aftersale_money_format'] = $aftersale['aftersale_money'] > 0 ? $dou->price_format($aftersale['aftersale_money']) : '无退款';
    $aftersale['is_handle'] = $aftersale['status'] ? true : false; // 是否可以操作售后
    $aftersale['status'] = $dou->data_lang_format('aftersale_status_', $aftersale['status']);
    $aftersale['add_time'] = date("Y-m-d H:i:s", $aftersale['add_time']);
    
    // 订单信息
    $aftersale['order'] = $dou->get_row('order', 'order_id, order_sn, phone, order_amount, shipping_time', "order_id = '$aftersale[order_id]'");
    
    $aftersale['order']['shipping_time'] = date("Y-m-d", $aftersale['order']['shipping_time']);
    // 订单信息
    $aftersale['user'] = $dou->get_row('user', 'user_id, user_sn, email', "user_id = '$aftersale[user_id]'");
 
    // 退货商品信息
    $aftersale['item_list'] = $dou_aftersale->get_aftersale_item_list($aftersale['order_id'], unserialize($aftersale['item_list']), true);
    
    // 格式化
    $aftersale['img_list'] = $dou->get_file_list('aftersale', $aftersale['order']['order_sn'], 'gallery', true);
    
    // 强制解锁
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('aftersale', $aftersale);
    $smarty->assign('unlock', $unlock);
    
    $smarty->display('aftersale.htm');
}

/**
 * +----------------------------------------------------------
 * 售后处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'handle') {
    // 验证并获取合法的ID
    $aftersale_id = $check->is_number($_REQUEST['aftersale_id']) ? $_REQUEST['aftersale_id'] : '';
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
    $aftersale_money = $check->is_price($_REQUEST['aftersale_money']) ? $_REQUEST['aftersale_money'] : $dou->dou_msg('金额输入有误');
 
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    // 售后信息
    $aftersale = $dou->get_row('aftersale', '*', "aftersale_id = '$aftersale_id'");
    if ($aftersale['status'] == 1 && !$unlock) // 强制解锁状态可以重复修改售后信息
        $dou->dou_msg('不能操作该售后服务单');
 
    // 订单信息
    $order = $dou->get_row('order', 'order_id, order_sn, module, item_link_status, order_amount', "order_id = '$aftersale[order_id]' AND status = '10'");
    if (!$order)
        $dou->dou_msg('售后服务单错误！可能原因：订单已取消、订单未取货、订单不存在', 'aftersale.php?rec=view&aftersale_id=' . $aftersale_id);
    
    // 验证退款金额
    if ($aftersale_money > $order['order_amount']) {
        $dou->dou_msg('退款金额大于订单总金额');
    }
    
    // 处理说明
    if (empty($_POST['handle_record']))
        $dou->dou_msg($_LANG['aftersale_handle_record'] . $_LANG['is_empty']);
 
    // 检查购物车是否有商品
    if (is_array($_POST['item_list'])) {
        $item_list_array = $_POST['item_list'];
        $item_list = ", item_list = '" . serialize($item_list_array) . "'";
    }
 
    // 格式化数据
    $handle_time = time();
 
    // 变更售后状态
    $update_aftersalse = $dou->query("UPDATE " . $dou->table('aftersale') . " SET aftersale_money = '$aftersale_money'" . $item_list . ", handle_record = '$_POST[handle_record]', handle_time = '$handle_time', `status` = '1' WHERE aftersale_id = '$aftersale_id'");
    if ($update_aftersalse) {
        // 升级订单状态：售后已完成
        $dou->query("UPDATE " . $dou->table('order') . " SET aftersale_status = '2' WHERE order_id = '$order[order_id]'");
     
        // 取消会员购买成功记录
        if ($order['item_link_status'] == '1')
            $dou->query("UPDATE " . $dou->table($order['module']) . " SET status = '0' WHERE order_sn = '$order[order_sn]'");
        
        // 将申请售后的商品在订单商品表中“aftersale”字段标记为1，代表申请过售后，这个字段用户后续统计商品申请过多少次售后
        foreach ((array)$item_list_array as $item_id) {
            $dou->query("UPDATE " . $dou->table('order_item') . " SET aftersale = '1' WHERE item_id = '$item_id' AND order_id = '$order[order_id]'");
        }
    } else {
        $update_aftersalse = $dou->query("UPDATE " . $dou->table('aftersale') . " SET aftersale_money = '0', handle_record = '$_POST[handle_record]', handle_time = '0', `status` = '0' WHERE aftersale_id = '$aftersale_id'");
        $dou->dou_msg($_LANG['aftersale_handle_wrong']);
    }
    
    $dou->dou_header('aftersale.php?rec=view&aftersale_id=' . $aftersale_id);
}

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'cancel_all') {
            // 售后批量删除
            $dou_aftersale->cancel_all($_POST['checkbox']);
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['aftersale_select_empty']);
    }
}

?>