<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Aftersale {
    /**
     * +----------------------------------------------------------
     * 生成唯一的退换货编号
     * +----------------------------------------------------------
     */
    function create_aftersale_sn() {
        // 随机生成订单号
        $aftersale_sn = str_pad(mt_rand(1, 99999), 5, '0', STR_PAD_LEFT);
        
        if ($GLOBALS['dou']->value_exist('aftersale', 'aftersale_sn', $aftersale_sn)) {
            $this->create_aftersale_sn();
        }

        return $aftersale_sn;
    }
 
    /**
     * +----------------------------------------------------------
     * 退换货.验证订单是否可以申请售后
     * +----------------------------------------------------------
     */
    function if_can_aftersale($order_id, $user_id) {
        // 订单状态
        $allow_aftersale = $GLOBALS['dou']->get_one("SELECT allow_aftersale FROM " . $GLOBALS['dou']->table('order') . " WHERE order_id = '$order_id' AND user_id = '$user_id' AND status = '10'");
     
        if ($allow_aftersale == '1') {
            return true;
        } else {
            return false;
        }
    }

    /**
     * +----------------------------------------------------------
     * 获取订单商品
     * +----------------------------------------------------------
     * $order_id 订单编号
     * +----------------------------------------------------------
     */
    function get_aftersale_item_list($order_id, $aftersale_item_list = array(), $show_all = false) {
        $aftersale_item_list = is_array($aftersale_item_list) ? $aftersale_item_list : array();
        
        /* 获取产品列表 */
        $query = $GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('order_item') . " WHERE order_id = '$order_id' ORDER BY id DESC");
        
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            if ($show_all) {
                $cur = in_array($row['item_id'], $aftersale_item_list) ? true : false;
            } else {
                if ($aftersale_item_list && !in_array($row['item_id'], $aftersale_item_list))
                    continue;
            }
            
            // 格式化价格
            $price = $GLOBALS['dou']->price_format($row['price']);
            $image = $GLOBALS['dou']->get_one("SELECT image FROM " . $GLOBALS['dou']->table($row['module']) . " WHERE id = '$row[item_id]'");
            $url = $GLOBALS['dou']->rewrite_url($row['module'], $row['item_id']);
            
            $item_list[] = array (
                    "item_id" => $row['item_id'],
                    "name" => $row['name'],
                    "thumb" => $GLOBALS['dou']->dou_file($image, true),
                    "url" => $url,
                    "cur" => $cur,
                    "item_number" => $row['item_number'],
                    "name" => $row['name'],
                    "price" => $price,
                    "defined" => $defined
            );
        }
        
        return $item_list;
    }
 
    /**
     * +----------------------------------------------------------
     * 售后状态信息
     * +----------------------------------------------------------
     */
    function order_aftersale_info($order_id) {
        $order = $GLOBALS['dou']->get_row('order', 'allow_aftersale, aftersale_status, aftersale_money', "order_id = '$order_id'");
        
        if ($order['aftersale_status'] == 1) {
            $order_aftersale_info['value'] = '处理中';
            $order_aftersale_info['class'] = 'cRed';
        } else if ($order['aftersale_status'] == 2) {
            $order_aftersale_info['value'] = $order['aftersale_money'] ? '退：' . $GLOBALS['dou']->price_format($aftersale_money) : '已处理';
            $order_aftersale_info['class'] = 'cBlu';
        } else {
            if ($order['allow_aftersale'] == 1) {
                $order_aftersale_info['value'] = '可申请';
                $order_aftersale_info['class'] = 'cGre';
            } else {
                $order_aftersale_info['value'] = '未申请';
                $order_aftersale_info['class'] = 'cGra';
            }
        }
     
        return $order_aftersale_info;
    }

}

?>