<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'user|apply|apply_post|filebox|filedel';
$subbox = array(
        "module" => 'aftersale',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'aftersale';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'user';

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/order.class.php');
$dou_order = new Order();

// 实例化售后功能
include_once (ROOT_PATH . 'include/aftersale.class.php');
$dou_aftersale = new Aftersale();

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
if (!file_exists($aftersale_file_path = ROOT_PATH . 'images/aftersale/'))
    mkdir($aftersale_file_path, 0777);
$file = new File('images/aftersale/' . date('Ymd') . '/'); // 实例化类文件(文件上传路径，结尾加斜杠)
 
// 需要登录且没有登录的情况
if (!is_array($_GLOBAL_USER))
    $dou->dou_header($_URL['login']);

// 当前会员ID
$user_id = $_GLOBAL_USER['user_id'];

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'user', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center($_CUR));
$smarty->assign('if_connect_plugin', $dou->value_exist('plugin', 'plugin_group', 'connect'));


/**
 * +----------------------------------------------------------
 * 售后服务.会员中心
 * +----------------------------------------------------------
 */
if ($rec == 'user') {
    // 公用SQL查询条件，分页中也使用
    $where = " WHERE user_id = '$user_id'";
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('aftersale') . $where . " ORDER BY aftersale_id DESC";

    // 验证并获取合法的分页ID
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, $_URL['sub']['user']);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        // 订单信息
        $order = $dou->get_row('order', 'order_sn, order_amount, shipping_time', "order_id = '$row[order_id]'");
        $order['url'] = $dou->param($dou->rewrite_url('user', 'order') . '&order_sn=' . $order['order_sn']);
        $order['shipping_time'] = date("Y-m-d", $order['shipping_time']);
       
        $aftersale_list[] = array (
                "aftersale_id" => $row['aftersale_id'],
                "aftersale_sn" => $row['aftersale_sn'],
                "order" => $order,
                "aftersale_money" => $dou->price_format($row['aftersale_money']),
                "item_list" => $dou_aftersale->get_aftersale_item_list($row['order_id'], unserialize($row['item_list'])),
                "img_list" => $dou->get_file_list('aftersale', $order['order_sn'], 'gallery', true),
                "reason" => $row['reason'],
                "handle_record" => $row['handle_record'],
                "status" => $dou->data_lang_format('aftersale_status_', $row['status']),
                "is_handle" => $row['status'] ? true : false,
                "add_time" => date("Y-m-d H:i", $row['add_time'])
                
        );
    }
    
    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'aftersale_list'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'aftersale_list'));
    $smarty->assign('head', $_LANG['aftersale_list']);
    $smarty->assign('aftersale_list', $aftersale_list);
    $smarty->assign('back_url', $_URL['sub']['user']);

    $smarty->display('aftersale.dwt');
}

/**
 * +----------------------------------------------------------
 * 售后服务.申请
 * +----------------------------------------------------------
 */
elseif ($rec == 'apply') {
    // 验证并获取合法的ID
    $order_sn = $check->is_number($_REQUEST['order_sn']) ? $_REQUEST['order_sn'] : '';
    $order = $dou->get_row('order', '*', "order_sn = '$order_sn' AND user_id = '$user_id'");
    
    // 判断订单是否存在
    if (!$order) $dou->dou_header($_URL['order_list']);
 
    // 验证码是否可以申请售后
    if (!$dou_aftersale->if_can_aftersale($order['order_id'], $user_id))
        $dou->dou_msg($_LANG['aftersale_apply_wrong'], $_URL['order_list'], 3);
 
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->set_token('aftersale_apply'));
 
    // 使用order_sn作为文件系统的item_id
    $item_id = $order['order_sn'];

    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('aftersale', 'aftersale_apply'));
    $smarty->assign('ur_here', $dou->ur_here('aftersale', 'aftersale_apply'));
    $smarty->assign('head', $_LANG['aftersale_apply']);
    $smarty->assign('item_list', $dou_aftersale->get_aftersale_item_list($order['order_id']));
    $smarty->assign('order', $order);
    $smarty->assign('item_id', $item_id);
    $smarty->assign('img_list_html', $dou->get_file_list('aftersale', $item_id, 'gallery'));

    $smarty->display('aftersale.dwt');
}

/**
 * +----------------------------------------------------------
 * 售后服务.提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'apply_post') {
    // 验证并获取合法的ID
    $order_sn = $check->is_number($_POST['order_sn']) ? $_POST['order_sn'] : '';
    
    // 验证售后原因
    if (!$_POST['reason']) {
        $wrong['reason'] = $_LANG['aftersale_reason'] . $_LANG['is_empty'];
    } elseif ($check->is_illegal_char($_POST['reason'])) {
        $wrong['reason'] = $_LANG['aftersale_reason'] . $_LANG['illegal_char'];
    }

    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format[$key] = '<p class="cue">' . $value . '</p>';
        }
        $dou->dou_msg($wrong_format, $_URL['sub']['user']);
    }

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token'], 'aftersale_apply');

    $order = $dou->get_row('order', 'order_id', "order_sn = '$_POST[order_sn]' AND user_id = '$user_id' AND allow_aftersale = '1'");
 
    if ($order) {
        // 检查购物车是否有商品
        if (is_array($_POST['item_list'])) {
            $item_list = serialize($_POST['item_list']);
        }

        // 获取和格式化数据
        $aftersale_sn = $dou_aftersale->create_aftersale_sn();
        $add_time = time();
        
        // 安全处理用户输入信息
        $_POST = $firewall->dou_foreground($_POST);

        // 售后信息插入
        $dou->query("INSERT INTO " . $dou->table('aftersale') . " (aftersale_id, aftersale_sn, order_id, user_id, item_list, reason, add_time)" . " VALUES (NULL, '$aftersale_sn', '$order[order_id]', '$user_id', '$item_list', '$_POST[reason]', '$add_time')");

        // 升级订单售后状态
        $dou->query("UPDATE " . $dou->table('order') . " SET allow_aftersale = '0', aftersale_status = '1' WHERE order_id = '$order[order_id]'");
     
        $dou->dou_msg($_LANG['aftersale_apply_success'], $_URL['aftersale'], 3);
    } else {
        $dou->dou_msg($_LANG['aftersale_apply_wrong'], $_URL['order_list'], 3);
    }
}

/**
 * +----------------------------------------------------------
 * 文件盒子
 * +----------------------------------------------------------
 */
elseif ($rec == 'filebox') {
    // 验证并获取合法的REQUEST
    $item_id = $check->is_number($_REQUEST['item_id']) ? $_REQUEST['item_id'] : ''; // 这里用到的是订单ID作为ITEM_ID
    $type = $check->is_letter($_REQUEST['type']) ? $_REQUEST['type'] : '';
    $img_width = $check->is_number($_REQUEST['img_width']) ? $_REQUEST['img_width'] : $_CFG['img_width'];
 
    // 先验证该订单是否属于该会员
    if (!$dou->value_exist('order', 'order_sn', $item_id, "user_id = '$user_id'"))
        die('');
    
    // 最多只能上传三张图片
    $file_number = $dou->get_one("SELECT COUNT(*) FROM " .$dou->table('file') . " WHERE module = 'aftersale' AND item_id = '$item_id' AND type = '$type'");
    if ($file_number < 3) {
        $custom_filename = $item_id . '_' . $type . '_' . $dou->create_rand_string('number', 6, time());
        $image = $file->box('aftersale', $item_id, $type . '_file', $type, $custom_filename, '', '', $img_width, $_CFG['watermark']);
    }

    // 显示已经上传的文件列表
    $html = $dou->get_file_list('aftersale', $item_id, $type);
    
    echo $html;
}

/**
 * +----------------------------------------------------------
 * 文件删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'filedel') {
    // 验证并获取合法的REQUEST
    $number = preg_match("/^[a-z0-9.]+$/", $_REQUEST['number']) ? $_REQUEST['number'] : '';
    $file_info = $dou->get_row('file', 'module, item_id, type', "number = '$number'");
    
    // 删除文件
    $dou->del_file($number);
 
    // 显示已经上传的文件列表
    $html = $dou->get_file_list($file_info['module'], $file_info['item_id'], $file_info['type']);
    
    echo $html;
}

?>