<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'aftersale_apply';
$subbox = array(
        "module" => 'aftersale',
        "sub" => $sub
);

require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'aftersale_list';

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/order.class.php');
$dou_order = new Order();

// 实例化售后功能
include_once (ROOT_PATH . 'include/aftersale.class.php');
$dou_aftersale = new Aftersale();

// 权限验证
$callback = $dou_user->check_login_state(); // 登录验证
if ($callback['msg'] == 'ok') {
    $user_id = $callback['user_id'];
} else {
    if (!in_array($rec, $nomust_login_array)) {
        $data['wrong'] = $_LANG['login_timeout'];
        die(json_encode($data));
    }
}

// 错误提示初始
$data['wrong'] = '';

/**
 * +----------------------------------------------------------
 * 售后服务.列表
 * +----------------------------------------------------------
 */
if ($rec == 'aftersale_list') {
    // 公用SQL查询条件，分页中也使用
    $where = " WHERE user_id = '$user_id'";
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('aftersale') . $where . " ORDER BY aftersale_id DESC";

    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, 10, $page);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        // 订单信息
        $order = $dou->get_row('order', 'order_sn, order_amount, shipping_time', "order_id = '$row[order_id]'");
        $order['url'] = $dou->param($_URL['user'] . '&order_sn=' . $order['order_sn']);
        $order['pick_time'] = date("Y-m-d", $order['pick_time']);
        
        $aftersale_list[] = array (
                "aftersale_id" => $row['aftersale_id'],
                "aftersale_sn" => $row['aftersale_sn'],
                "order" => $order,
                "aftersale_money" => $dou->price_format($row['aftersale_money']),
                "item_list" => $dou_aftersale->get_aftersale_item_list($row['order_id'], unserialize($row['item_list'])),
                "reason" => $row['reason'],
                "handle_record" => $row['handle_record'],
                "status" => $dou->data_lang_format('aftersale_status_', $row['status']),
                "is_handle" => $row['status'] ? true : false,
                "add_time" => date("Y-m-d H:i", $row['add_time'])
                
        );
    }
 
    // 数据封装
    $data['sql'] = $sql;
    $data['title'] = $_LANG['aftersale_list'];
    $data['aftersale_list'] = $aftersale_list;
}

/**
 * +----------------------------------------------------------
 * 售后服务.申请
 * +----------------------------------------------------------
 */
elseif ($rec == 'aftersale_apply') {
    // 验证并获取合法的ID
    $order_sn = $check->is_number($_REQUEST['order_sn']) ? $_REQUEST['order_sn'] : '';
    $order = $dou->get_row('order', '*', "order_sn = '$order_sn' AND user_id = '$user_id'");
 
    // 使用order_sn作为文件系统的item_id
    $item_id = $order['order_sn'];
    
    // 判断订单是否存在
    if ($order) {
        // 验证码是否可以申请售后
        if (!$dou_aftersale->if_can_aftersale($order['order_id'], $user_id))
            $data['wrong'] = $_LANG['aftersale_apply_wrong'];
        
        $data['item_list'] = $dou_aftersale->get_aftersale_item_list($order['order_id']);
        $data['order'] = $order;
        $data['html_file_list'] = $dou_aftersale->html_file_list('aftersale', $item_id, 'gallery', true);
    } else {
        $data['wrong'] = $_LANG['aftersale_apply_wrong'];
        $data['item_list'] = array();
        $data['order'] = array();
        $data['html_file_list'] = array();
    }
 
    // 数据封装
    $data['title'] = $_LANG['aftersale_apply'];
}

/**
 * +----------------------------------------------------------
 * 售后服务.提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'aftersale_apply_post') {
    // 验证并获取合法的ID
    $order_sn = $check->is_number($_POST['order_sn']) ? $_POST['order_sn'] : '';
    
    // 验证售后原因
    if (!$_POST['reason']) {
        $data['wrong'] = $_LANG['aftersale_reason'] . $_LANG['is_empty'];
    } elseif ($check->is_illegal_char($_POST['reason'])) {
        $data['wrong'] = $_LANG['aftersale_reason'] . $_LANG['illegal_char'];
    }

    if (!$wrong && $order_sn) {
        $order = $dou->get_row('order', 'order_id', "order_sn = '$order_sn' AND user_id = '$user_id' AND allow_aftersale = '1'");

        if ($order) {
            // 检查购物车是否有商品
            if ($_POST['item_list']) {
                $item_list = serialize(explode(',', $_POST['item_list']));
            }

            // 获取和格式化数据
            $aftersale_sn = $dou_aftersale->create_aftersale_sn();
            $add_time = time();

            // 安全处理用户输入信息
            $_POST = $firewall->dou_foreground($_POST);

            // 售后信息插入
            $dou->query("INSERT INTO " . $dou->table('aftersale') . " (aftersale_id, aftersale_sn, order_id, user_id, item_list, reason, add_time)" . " VALUES (NULL, '$aftersale_sn', '$order[order_id]', '$user_id', '$item_list', '$_POST[reason]', '$add_time')");
         
            // 升级订单售后状态
            $dou->query("UPDATE " . $dou->table('order') . " SET allow_aftersale = '0', aftersale_status = '1' WHERE order_id = '$order[order_id]'");
        } else {
            $data['wrong'] = $_LANG['aftersale_apply_wrong'];
        }
    }
}

/**
 * +----------------------------------------------------------
 * 文件盒子
 * +----------------------------------------------------------
 */
elseif ($rec == 'filebox') {
    // 图片上传
    include_once (ROOT_PATH . 'include/file.class.php');
    $file = new File('images/aftersale/' . date('Ymd') . '/'); // 实例化类文件(文件上传路径，结尾加斜杠)
 
    // 验证并获取合法的REQUEST
    $item_id = $check->is_number($_REQUEST['order_sn']) ? $_REQUEST['order_sn'] : ''; // 这里用到的是订单ID作为ITEM_ID
 
    // 先验证该订单是否属于该会员
    if (!$dou->value_exist('order', 'order_sn', $item_id, "user_id = '$user_id'")) {
        $data['html_file_list'] = array();
    } else {
        // 最多只能上传三张图片
        $file_number = $dou->get_one("SELECT COUNT(*) FROM " .$dou->table('file') . " WHERE module = 'aftersale' AND item_id = '$item_id' AND type = 'gallery'");
        if ($file_number < 3) {
            // 文件上传盒子
            $custom_filename = $item_id . '_' . $dou->create_rand_string('letter', 6, date('Ymd'));
            $image = $file->box('aftersale', $item_id, 'gallery', 'gallery', $custom_filename);
        }

        // 显示已经上传的文件列表
        $data['html_file_list'] = $dou->get_file_list('aftersale', $item_id, 'gallery', true);
    }
}

/**
 * +----------------------------------------------------------
 * 文件删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'filedel') {
    // 验证并获取合法的REQUEST
    $item_id = $check->is_number($_REQUEST['order_sn']) ? $_REQUEST['order_sn'] : '';
    $number = preg_match("/^[a-z0-9.]+$/", $_REQUEST['number']) ? $_REQUEST['number'] : '';
    
    // 删除文件
    $dou_aftersale->del_file($number);
 
    // 显示已经上传的文件列表
    $data['html_file_list'] = $dou->get_file_list('aftersale', $item_id, 'gallery', true);
}

echo json_encode($data);

?>