// pages/aftersale/aftersale.js

// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    aftersale_list: [],
    page: 1, // 初始页默认值为1
    nomore: false
  },
 
  onLoad: function(options) {
    var that = this
        
    wx.setNavigationBarTitle({
      title: app.title.aftersale
    })
    
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
   
    that.loadData()
  },
 
  onShow: function(options) {
    // 判断是否登录
    dou.checkLoginState('page', '/pages/user/user')
  },
 
  loadData: function(concat = false, page = '') {
    var that = this
    
    wx.request({
      url: app.mp_url + 'aftersale.php',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        page: page ? page : that.data.page // 从数据里获取当前页数
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (concat) {
          var dataBox = that.data.aftersale_list; // 从data获取当前datalist数组
          var dataNew = res.data.aftersale_list; // 从此次请求返回的数据中获取新数组
          
          if (dataNew) {
            dataBox = dataBox.concat(dataNew); // 合并数组
          } else {
            that.setData({
              nomore: true
            })
          }
        } else {
          dataBox = res.data.aftersale_list;
        }
        
        that.setData({
          aftersale_list: dataBox,
          loadpage: false
        })
      },
    })
  },
 
  onReachBottom: function () { // 触底开始下一页
    var that = this;
    
    if (!that.data.nomore) {
      var page = that.data.page + 1; // 获取当前页数并+1
    
      that.setData({
        page: page, // 更新当前页数
        loadpage: true,//加载动画的显示
      })

      setTimeout (
        function() { //注意function这里不能缺少
          that.loadData(true); // 重新调用请求获取下一页数据
        },1000
      )
    }
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }


})