// pages/aftersale/aftersale_apply.js

// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  onShow: function(options) {
    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
    
    wx.setNavigationBarTitle({
      title: app.title.aftersale_apply
    })
        
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      }
    })
    
    wx.request({
      url: app.mp_url + 'aftersale.php?rec=aftersale_apply',
      data: {
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell'),
        'order_sn': options.order_sn
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong, '/pages/order/order_list')
        } else {
          that.setData({
            item_list: res.data.item_list,
            order: res.data.order,
            html_file_list: res.data.html_file_list
          })
        }
      },
    })
  },
 
  checkboxChange: function(e) {
    this.setData({
      item_list_data: e.detail.value
    })
  },
 
  aftersaleApply: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.request({
    url: app.mp_url + 'aftersale.php?rec=aftersale_apply_post',
    data: {
      user_id: wx.getStorageSync('user_id'),
      shell: wx.getStorageSync('shell'),
      'order_sn': e.detail.value.order_sn,
      'reason': e.detail.value.reason
    },
    method:'POST',
    header: {
      'Connect-Key' : wx.getStorageSync('connect_key'),
      'Content-Type': 'application/x-www-form-urlencoded'
    },
    success: function (res) {
      if (res.data.wrong) {
        dou.douMsg(res.data.wrong)
      } else {
        // 跳转到提货人列表页
        wx.navigateTo ({
          url: '/pages/aftersale/aftersale'
        })
      }
    }
   })
  },
 
  filebox: function(e) {
    var that = this;
    
    wx.chooseImage ({ //从本地相册选择图片或使用相机拍照
      count: 1, // 默认9
      sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
      sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
      success: function(info) {
        // 返回选定照片的本地文件路径列表，tempFilePath可以作为img标签的src属性显示图片
        var tempFilePaths = info.tempFilePaths;
        
        wx.uploadFile ({
          url: app.mp_url + 'aftersale.php?rec=filebox',
          filePath: tempFilePaths[0],
          formData: {
            'user_id': wx.getStorageSync('user_id'),
            'shell': wx.getStorageSync('shell'),
            'order_sn': e.currentTarget.dataset.order_sn
          },
          method:'POST',
          header: {
            'Connect-Key' : wx.getStorageSync('connect_key'),
            'Content-Type': 'application/x-www-form-urlencoded'
          },
          name: 'gallery',
          success: function(res) {
            var data = JSON.parse(res.data) //与wx.request不同，wx.uploadFile返回的是[字符串]，需要自己转为JSON格式
            
            that.setData({
              html_file_list: data.html_file_list
            })
          }
        })
      }
    })
  },
 
  fileDel: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.request({
    url: app.mp_url + 'aftersale.php?rec=filedel',
    data: {
      user_id: wx.getStorageSync('user_id'),
      shell: wx.getStorageSync('shell'),
      'number': e.currentTarget.dataset.number,
      'order_sn': e.currentTarget.dataset.order_sn
    },
    method:'POST',
    header: {
      'Connect-Key' : wx.getStorageSync('connect_key'),
      'Content-Type': 'application/x-www-form-urlencoded'
    },
    success: function (res) {
      that.setData({
        html_file_list: res.data.html_file_list
      })
    }
   })
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }


})